import { UseReducerContextSource, CurrentState } from './createUseReducerContext';
import { ReducerState, ReducerDispatch } from './createContext';
import { StateContexts, DispatchContext } from '../core/createContext';
export declare type UseGlobalState<T extends UseReducerContextSource> = {
    [P in keyof T]: {
        (): ReducerState<T[P]['reducer']>;
        <SelectedState>(selector: (state: ReducerState<T[P]['reducer']>) => SelectedState): SelectedState;
    };
};
export declare type UseGlobalDispatch<T extends UseReducerContextSource> = () => {
    [P in keyof T]: ReducerDispatch<T[P]['reducer']>;
};
export declare const createStore: <T extends UseReducerContextSource>(stateContexts: StateContexts<T>, dispatchContext: DispatchContext<T>, getCurrentState: () => CurrentState<T>) => {
    useGlobalState: UseGlobalState<T>;
    useGlobalDispatch: UseGlobalDispatch<T>;
};
