import React from 'react';
import { UseStateContextSource } from './createUseStateContext';
import { UseGlobalDispatch } from './hook';
import { ContextProvider } from '../core/createContext';
export declare type UseStateContext<T extends UseStateContextSource> = {
    [P in keyof T]: {
        state: React.Context<T[P]>;
        dispatch: React.Context<React.Dispatch<React.SetStateAction<T[P]>>>;
    };
};
export declare const createContext: <T extends UseStateContextSource>(contextSource: T) => {
    useGlobalState: import("./hook").UseGlobalState<T>;
    useGlobalDispatch: UseGlobalDispatch<T>;
    contextProvider: React.FC<ContextProvider<T>>;
    getState: () => T;
};
