import React from 'react';
import { UseStateContextSource } from './createUseStateContext';
import { UseStateContext } from './createContext';
import { StateContexts, DispatchContext } from '../core/createContext';
export declare type UseGlobalState<T extends UseStateContextSource> = {
    [P in keyof T]: {
        (): T[P];
        <SelectedState>(selector: (state: T[P]) => SelectedState): SelectedState;
    };
};
export declare type UseGlobalDispatch<T extends UseStateContextSource> = () => {
    [P in keyof T]: React.Dispatch<React.SetStateAction<T[P]>>;
};
export declare const createStore: <T extends UseStateContextSource>(stateContexts: StateContexts<UseStateContext<T>>, dispatchContext: DispatchContext<UseStateContext<T>>, getCurrentState: () => T) => {
    useGlobalState: UseGlobalState<T>;
    useGlobalDispatch: UseGlobalDispatch<T>;
};
